<template>
  <div class="banner">
    <div class="banner-title">Танзими <b> баннер </b></div>
    <form @submit.prevent="uploadBanner()">
      <div class="banner-wrapper">
        <input
          type="file"
          accept=".png,image/png,.jpg,image/jpg,.jpeg,image/jpeg"
          aria-label="upload image button"
          @change="inputImage"
          style="display: none"
          ref="fileInput"
          required
        />
        <span>Истинодро барои баннер ҷойгир намоед</span>
        <Input type="text" required v-model="banner.link" />
        <button type="button" @click="$refs.fileInput.click()" class="form-btn">
          {{
            is_already_banner ? "Тағир додани тасвир" : "Тасвирро замима намоед"
          }}
        </button>
      </div>
      <img :src="banner_blob" />
      <button type="submit" class="curve-btn">
        <div>
          {{ is_already_banner ? "Изменить баннер" : "Добавить баннер" }}
        </div>
      </button>
    </form>
  </div>
</template>

<script>
export default {
  layout: "profile",
  middleware: "auth",
  data() {
    return {
      banner: {
        img: null,
        link: "",
      },
      banner_image: null,
      banner_blob: null,
      is_already_banner: false,
      banner_for_remove: null,
    };
  },
  fetchOnServer: false,
  fetch() {
    this.getBanner();
  },
  methods: {
    getBanner() {
      this.$axios
        .$get("/settings/getBanner")
        .then((response) => {
          if (response.length > 0) {
            this.is_already_banner = true;
            this.banner_blob = response[0].img;
            this.banner_for_remove = response[0].img;
            this.banner.link = response[0].link;
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },

    uploadBanner() {
      this.uploadImage()
        .then(() => {
          this.$axios
            .$post("/settings/uploadBanner", this.banner)
            .then(() => {
              this.removeImage();
            })
            .catch((err) => console.log(err));
        })
        .catch((err) => console.log(err));
    },

    removeImage() {
      const url = this.$config.UPLOADS_BACKEND_URL + "/removeBanner";
      console.log(this.banner_for_remove);
      this.$axios
        .$post(url, { path: "./static" + this.banner_for_remove })
        .catch((error) => {
          console.log(error);
        });
    },

    async uploadImage() {
      const imageName =
        Math.floor(Math.random() * 100001) +
        "." +
        this.banner_image.type.split("/").pop().trim();
      const formData = new FormData();
      formData.append("banner", this.banner_image, imageName);
      const url = this.$config.UPLOADS_BACKEND_URL + "/uploadBanner";
      try {
        let response = await this.$axios.$post(url, formData, {
          headers: {
            "content-type": "multipart/form-data",
          },
        });
        if (response.answer === "ok") {
          this.banner.img = "/banner/" + imageName;
        }
      } catch (err) {
        throw new Error("uploadImage error", err);
      }
    },

    async inputImage(e) {
      // Math.floor(Math.random() * 100001)

      const banner = e.target.files[0];
      if (banner === undefined) {
        return;
      }
      if (banner.size > 524288) {
        alert("Андозаи акс набояд аз 500 килобайт зиёд бошад ");
      } else {
        const reader = new FileReader();
        reader.readAsDataURL(banner);
        reader.onload = (onloadEvent) => {
          this.banner_blob = onloadEvent.target.result;
          this.banner_image = banner;
        };
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.banner {
  margin-left: 20px;
  padding: 20px;
  background-color: #fff;
  box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
  width: 100%;
  @include less-than(tablet) {
    margin-left: 0px;
  }

  &-title {
    line-height: 1.3;
    font-size: 36px;

    b {
    }
  }

  &-wrapper {
    margin-top: 20px;
    @include less-than(tablet) {
      margin-top: 20px;
      //   margin-left: 10px;
      justify-content: center;
      flex-wrap: wrap;
      flex-direction: column;
    }
    span {
      display: block;
      margin-bottom: 5px;
      line-height: 1;
    }
    button {
      transition: all ease 0.3s;
      margin-right: 20px;
      margin-top: 20px;
      @include less-than(tablet) {
        margin-left: 0px;
      }
      &:hover {
        color: #0c63e4;
      }
    }
  }
  img {
    margin-top: 30px;
    width: 300px;
    height: 500px;
    border: 1px solid #ccc;
  }
  .curve-btn {
    margin-top: 30px;
  }
}
</style>
